Status: Resolved Priority: Should have
Author: Robert Lemke Category:
Created: 2010-09-02 Assigned To: Robert Lemke
Updated: 2012-03-16 Due date:
Sprint:
PHP Version:
Has patch: No
Complexity: hard
Subject: Improve speed of AOP proxy building / reflection
Description

The process of AOP proxy building and the extensive use of relfection has slowed down FLOW3 immensely, especially in
Development context.

There are several possible measures to make it faster again - on the one hand in the proxy building mechanism itself, but also in the
ReflectionService.

The initialization of the AOP framework currently takes 96% of the overall script execution time (ie. 11,0145364 seconds in my test
case).

We should bring this below 2 seconds for the following scenario:
- TYPO3 base distribution
  - one change in a single class (e.g. a controller)
  - next hit should be below 2 secs.

Associated revisions
Revision 962d2be2 - 2010-09-02 18:43 - Robert Lemke

[~TASK] FLOW3: Doubled speed of proxy building in Development context

Improved speed of getInterfaceNamesImplementedByClass() in the Reflection
Service by using PHP's native function. Previously array_search was
called more than 4,000,000 times in this method.

This is not a real solution, but at least a quick relief. We need to
take more measures and do more profiling as outlined in the related
issue.

Relates to: #9568

Change-Id: If6bce5c386b6b8ce1c51ec4a49386c69bdfc1560

Revision 9c3a9dca - 2011-10-26 21:36 - Robert Lemke

[TASK] Optimized AOP Pointcut Filter matching

This change set greatly reduces compilation time for AOP proxies for
applications intensively using AOP and security policies. It is a quick
fix rather than the ultimate solution.

Class name and method name matching have been simplified, matching
against annotations does not support regular expressions any more
(wasn't supported officially anyway) and the order of a few point cut
expressions has been optimized.

Related: #9568
Releases: 1.0, 1.1

Change-Id: I783d6052802b5bcc7cd48b1f4e2d9335bbc99612

Revision 66df0697 - 2011-11-01 21:08 - Robert Lemke

[TASK] Optimized AOP Pointcut Filter matching

This change set greatly reduces compilation time for AOP proxies for
applications intensively using AOP and security policies. It is a quick
fix rather than the ultimate solution.

Class name and method name matching have been simplified, matching
against annotations does not support regular expressions any more
(wasn't supported officially anyway) and the order of a few point cut
expressions has been optimized.

Change-Id: Ib2350f02fa5dcbda5dda9337b1cab54714958c16
Related: #9568
Releases: 1.0, 1.1

Revision 38c3c8e7 - 2012-03-15 15:11 - Andreas Förthner

[FEATURE] Optimize AOP proxy building

This simply makes AOP proxy building a lot faster.

Change-Id: I55a9bc34edba10539ef2df548e2bd0958fc15f07
Resolves: #9568
Resolves: PHX-72
Releases: 1.1

History
#1 - 2010-10-15 15:06 - Karsten Dambekalns
- Target version changed from 1.0 alpha 12 to 1.0 alpha 13

#2 - 2010-11-16 16:42 - Karsten Dambekalns
- Target version changed from 1.0 alpha 13 to 1.0 alpha 14

#3 - 2011-08-29 21:36 - Karsten Dambekalns
- Target version changed from 1.0 alpha 14 to 1230
#4 - 2011-10-20 01:43 - Karsten Dambekalns
- Target version deleted (1230)

#5 - 2011-10-25 10:52 - Robert Lemke
- Target version set to 1.1
- Has patch set to No

#6 - 2011-10-25 10:52 - Robert Lemke
- Complexity set to hard

#7 - 2012-03-14 13:50 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 8 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9623

#8 - 2012-03-14 15:42 - Gerrit Code Review

Patch set 9 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9623

#9 - 2012-03-14 18:26 - Gerrit Code Review

Patch set 12 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9623

#10 - 2012-03-14 19:15 - Gerrit Code Review

Patch set 13 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9623

#11 - 2012-03-14 21:40 - Gerrit Code Review

Patch set 14 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9623

#12 - 2012-03-15 10:42 - Gerrit Code Review

Patch set 15 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9623

#13 - 2012-03-15 11:44 - Gerrit Code Review

Patch set 16 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9623
#14 - 2012-03-15 12:08 - Gerrit Code Review

Patch set 17 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9623

#15 - 2012-03-15 15:04 - Gerrit Code Review

Patch set 18 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9623

#16 - 2012-03-15 15:09 - Gerrit Code Review

Patch set 19 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9623

#17 - 2012-03-15 15:12 - Gerrit Code Review

Patch set 20 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9623

#18 - 2012-03-16 02:41 - Andreas Förthner
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:38c3c8e7edbb730699dbd993e180e8aee39b3e3d.
